# coding=utf-8
# *** WARNING: this file was generated by the Pulumi Terraform Bridge (tfgen) Tool. ***
# *** Do not edit by hand unless you're certain you know what you are doing! ***

import copy
import warnings
import pulumi
import pulumi.runtime
from typing import Any, Callable, Mapping, Optional, Sequence, Union, overload
from . import _utilities
from ._enums import *

__all__ = [
    'ConnectionPortArgs',
    'DeviceIpAddressArgs',
    'DeviceNetworkArgs',
    'DevicePortArgs',
    'DeviceReinstallArgs',
    'ProjectBgpConfigArgs',
    'SpotMarketRequestInstanceParametersArgs',
    'VolumeAttachmentArgs',
    'VolumeSnapshotPolicyArgs',
    'GetFacilityCapacityArgs',
    'GetMetroCapacityArgs',
]

@pulumi.input_type
class ConnectionPortArgs:
    def __init__(__self__, *,
                 id: Optional[pulumi.Input[str]] = None,
                 link_status: Optional[pulumi.Input[str]] = None,
                 name: Optional[pulumi.Input[str]] = None,
                 role: Optional[pulumi.Input[str]] = None,
                 speed: Optional[pulumi.Input[int]] = None,
                 status: Optional[pulumi.Input[str]] = None,
                 virtual_circuit_ids: Optional[pulumi.Input[Sequence[Any]]] = None):
        """
        :param pulumi.Input[str] name: Name of the connection resource
        :param pulumi.Input[int] speed: Port speed in bits per second
        :param pulumi.Input[str] status: Status of the connection resource
        """
        ConnectionPortArgs._configure(
            lambda key, value: pulumi.set(__self__, key, value),
            id=id,
            link_status=link_status,
            name=name,
            role=role,
            speed=speed,
            status=status,
            virtual_circuit_ids=virtual_circuit_ids,
        )
    @staticmethod
    def _configure(
             _setter: Callable[[Any, Any], None],
             id: Optional[pulumi.Input[str]] = None,
             link_status: Optional[pulumi.Input[str]] = None,
             name: Optional[pulumi.Input[str]] = None,
             role: Optional[pulumi.Input[str]] = None,
             speed: Optional[pulumi.Input[int]] = None,
             status: Optional[pulumi.Input[str]] = None,
             virtual_circuit_ids: Optional[pulumi.Input[Sequence[Any]]] = None,
             opts: Optional[pulumi.ResourceOptions]=None):
        if id is not None:
            _setter("id", id)
        if link_status is not None:
            _setter("link_status", link_status)
        if name is not None:
            _setter("name", name)
        if role is not None:
            _setter("role", role)
        if speed is not None:
            _setter("speed", speed)
        if status is not None:
            _setter("status", status)
        if virtual_circuit_ids is not None:
            _setter("virtual_circuit_ids", virtual_circuit_ids)

    @property
    @pulumi.getter
    def id(self) -> Optional[pulumi.Input[str]]:
        return pulumi.get(self, "id")

    @id.setter
    def id(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "id", value)

    @property
    @pulumi.getter(name="linkStatus")
    def link_status(self) -> Optional[pulumi.Input[str]]:
        return pulumi.get(self, "link_status")

    @link_status.setter
    def link_status(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "link_status", value)

    @property
    @pulumi.getter
    def name(self) -> Optional[pulumi.Input[str]]:
        """
        Name of the connection resource
        """
        return pulumi.get(self, "name")

    @name.setter
    def name(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "name", value)

    @property
    @pulumi.getter
    def role(self) -> Optional[pulumi.Input[str]]:
        return pulumi.get(self, "role")

    @role.setter
    def role(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "role", value)

    @property
    @pulumi.getter
    def speed(self) -> Optional[pulumi.Input[int]]:
        """
        Port speed in bits per second
        """
        return pulumi.get(self, "speed")

    @speed.setter
    def speed(self, value: Optional[pulumi.Input[int]]):
        pulumi.set(self, "speed", value)

    @property
    @pulumi.getter
    def status(self) -> Optional[pulumi.Input[str]]:
        """
        Status of the connection resource
        """
        return pulumi.get(self, "status")

    @status.setter
    def status(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "status", value)

    @property
    @pulumi.getter(name="virtualCircuitIds")
    def virtual_circuit_ids(self) -> Optional[pulumi.Input[Sequence[Any]]]:
        return pulumi.get(self, "virtual_circuit_ids")

    @virtual_circuit_ids.setter
    def virtual_circuit_ids(self, value: Optional[pulumi.Input[Sequence[Any]]]):
        pulumi.set(self, "virtual_circuit_ids", value)


@pulumi.input_type
class DeviceIpAddressArgs:
    def __init__(__self__, *,
                 type: pulumi.Input[str],
                 cidr: Optional[pulumi.Input[int]] = None,
                 reservation_ids: Optional[pulumi.Input[Sequence[pulumi.Input[str]]]] = None):
        """
        :param pulumi.Input[str] type: One of [`private_ipv4`, `public_ipv4`, `public_ipv6`]
        :param pulumi.Input[int] cidr: CIDR suffix for IP address block to be assigned, i.e. amount of addresses.
        :param pulumi.Input[Sequence[pulumi.Input[str]]] reservation_ids: List of UUIDs of IP block reservations from which the public IPv4 address should be taken.
               
               You can supply one `ip_address` block per IP address type. If you use the `ip_address` you must always pass a block for `private_ipv4`.
               
               To learn more about using the reserved IP addresses for new devices, see the examples in the ReservedIpBlock documentation.
               
               The `reinstall` block has 3 fields:
        """
        DeviceIpAddressArgs._configure(
            lambda key, value: pulumi.set(__self__, key, value),
            type=type,
            cidr=cidr,
            reservation_ids=reservation_ids,
        )
    @staticmethod
    def _configure(
             _setter: Callable[[Any, Any], None],
             type: pulumi.Input[str],
             cidr: Optional[pulumi.Input[int]] = None,
             reservation_ids: Optional[pulumi.Input[Sequence[pulumi.Input[str]]]] = None,
             opts: Optional[pulumi.ResourceOptions]=None):
        _setter("type", type)
        if cidr is not None:
            _setter("cidr", cidr)
        if reservation_ids is not None:
            _setter("reservation_ids", reservation_ids)

    @property
    @pulumi.getter
    def type(self) -> pulumi.Input[str]:
        """
        One of [`private_ipv4`, `public_ipv4`, `public_ipv6`]
        """
        return pulumi.get(self, "type")

    @type.setter
    def type(self, value: pulumi.Input[str]):
        pulumi.set(self, "type", value)

    @property
    @pulumi.getter
    def cidr(self) -> Optional[pulumi.Input[int]]:
        """
        CIDR suffix for IP address block to be assigned, i.e. amount of addresses.
        """
        return pulumi.get(self, "cidr")

    @cidr.setter
    def cidr(self, value: Optional[pulumi.Input[int]]):
        pulumi.set(self, "cidr", value)

    @property
    @pulumi.getter(name="reservationIds")
    def reservation_ids(self) -> Optional[pulumi.Input[Sequence[pulumi.Input[str]]]]:
        """
        List of UUIDs of IP block reservations from which the public IPv4 address should be taken.

        You can supply one `ip_address` block per IP address type. If you use the `ip_address` you must always pass a block for `private_ipv4`.

        To learn more about using the reserved IP addresses for new devices, see the examples in the ReservedIpBlock documentation.

        The `reinstall` block has 3 fields:
        """
        return pulumi.get(self, "reservation_ids")

    @reservation_ids.setter
    def reservation_ids(self, value: Optional[pulumi.Input[Sequence[pulumi.Input[str]]]]):
        pulumi.set(self, "reservation_ids", value)


@pulumi.input_type
class DeviceNetworkArgs:
    def __init__(__self__, *,
                 address: Optional[pulumi.Input[str]] = None,
                 cidr: Optional[pulumi.Input[int]] = None,
                 family: Optional[pulumi.Input[int]] = None,
                 gateway: Optional[pulumi.Input[str]] = None,
                 public: Optional[pulumi.Input[bool]] = None):
        """
        :param pulumi.Input[str] address: IPv4 or IPv6 address string
        :param pulumi.Input[int] cidr: CIDR suffix for IP address block to be assigned, i.e. amount of addresses.
        :param pulumi.Input[int] family: IP version - "4" or "6"
        :param pulumi.Input[str] gateway: address of router
        :param pulumi.Input[bool] public: whether the address is routable from the Internet
        """
        DeviceNetworkArgs._configure(
            lambda key, value: pulumi.set(__self__, key, value),
            address=address,
            cidr=cidr,
            family=family,
            gateway=gateway,
            public=public,
        )
    @staticmethod
    def _configure(
             _setter: Callable[[Any, Any], None],
             address: Optional[pulumi.Input[str]] = None,
             cidr: Optional[pulumi.Input[int]] = None,
             family: Optional[pulumi.Input[int]] = None,
             gateway: Optional[pulumi.Input[str]] = None,
             public: Optional[pulumi.Input[bool]] = None,
             opts: Optional[pulumi.ResourceOptions]=None):
        if address is not None:
            _setter("address", address)
        if cidr is not None:
            _setter("cidr", cidr)
        if family is not None:
            _setter("family", family)
        if gateway is not None:
            _setter("gateway", gateway)
        if public is not None:
            _setter("public", public)

    @property
    @pulumi.getter
    def address(self) -> Optional[pulumi.Input[str]]:
        """
        IPv4 or IPv6 address string
        """
        return pulumi.get(self, "address")

    @address.setter
    def address(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "address", value)

    @property
    @pulumi.getter
    def cidr(self) -> Optional[pulumi.Input[int]]:
        """
        CIDR suffix for IP address block to be assigned, i.e. amount of addresses.
        """
        return pulumi.get(self, "cidr")

    @cidr.setter
    def cidr(self, value: Optional[pulumi.Input[int]]):
        pulumi.set(self, "cidr", value)

    @property
    @pulumi.getter
    def family(self) -> Optional[pulumi.Input[int]]:
        """
        IP version - "4" or "6"
        """
        return pulumi.get(self, "family")

    @family.setter
    def family(self, value: Optional[pulumi.Input[int]]):
        pulumi.set(self, "family", value)

    @property
    @pulumi.getter
    def gateway(self) -> Optional[pulumi.Input[str]]:
        """
        address of router
        """
        return pulumi.get(self, "gateway")

    @gateway.setter
    def gateway(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "gateway", value)

    @property
    @pulumi.getter
    def public(self) -> Optional[pulumi.Input[bool]]:
        """
        whether the address is routable from the Internet
        """
        return pulumi.get(self, "public")

    @public.setter
    def public(self, value: Optional[pulumi.Input[bool]]):
        pulumi.set(self, "public", value)


@pulumi.input_type
class DevicePortArgs:
    def __init__(__self__, *,
                 bonded: Optional[pulumi.Input[bool]] = None,
                 id: Optional[pulumi.Input[str]] = None,
                 mac: Optional[pulumi.Input[str]] = None,
                 name: Optional[pulumi.Input[str]] = None,
                 type: Optional[pulumi.Input[str]] = None):
        """
        :param pulumi.Input[bool] bonded: Whether this port is part of a bond in bonded network setup
        :param pulumi.Input[str] id: ID of the port
        :param pulumi.Input[str] mac: MAC address assigned to the port
        :param pulumi.Input[str] name: Name of the port (e.g. `eth0`, or `bond0`)
        :param pulumi.Input[str] type: One of [`private_ipv4`, `public_ipv4`, `public_ipv6`]
        """
        DevicePortArgs._configure(
            lambda key, value: pulumi.set(__self__, key, value),
            bonded=bonded,
            id=id,
            mac=mac,
            name=name,
            type=type,
        )
    @staticmethod
    def _configure(
             _setter: Callable[[Any, Any], None],
             bonded: Optional[pulumi.Input[bool]] = None,
             id: Optional[pulumi.Input[str]] = None,
             mac: Optional[pulumi.Input[str]] = None,
             name: Optional[pulumi.Input[str]] = None,
             type: Optional[pulumi.Input[str]] = None,
             opts: Optional[pulumi.ResourceOptions]=None):
        if bonded is not None:
            _setter("bonded", bonded)
        if id is not None:
            _setter("id", id)
        if mac is not None:
            _setter("mac", mac)
        if name is not None:
            _setter("name", name)
        if type is not None:
            _setter("type", type)

    @property
    @pulumi.getter
    def bonded(self) -> Optional[pulumi.Input[bool]]:
        """
        Whether this port is part of a bond in bonded network setup
        """
        return pulumi.get(self, "bonded")

    @bonded.setter
    def bonded(self, value: Optional[pulumi.Input[bool]]):
        pulumi.set(self, "bonded", value)

    @property
    @pulumi.getter
    def id(self) -> Optional[pulumi.Input[str]]:
        """
        ID of the port
        """
        return pulumi.get(self, "id")

    @id.setter
    def id(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "id", value)

    @property
    @pulumi.getter
    def mac(self) -> Optional[pulumi.Input[str]]:
        """
        MAC address assigned to the port
        """
        return pulumi.get(self, "mac")

    @mac.setter
    def mac(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "mac", value)

    @property
    @pulumi.getter
    def name(self) -> Optional[pulumi.Input[str]]:
        """
        Name of the port (e.g. `eth0`, or `bond0`)
        """
        return pulumi.get(self, "name")

    @name.setter
    def name(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "name", value)

    @property
    @pulumi.getter
    def type(self) -> Optional[pulumi.Input[str]]:
        """
        One of [`private_ipv4`, `public_ipv4`, `public_ipv6`]
        """
        return pulumi.get(self, "type")

    @type.setter
    def type(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "type", value)


@pulumi.input_type
class DeviceReinstallArgs:
    def __init__(__self__, *,
                 deprovision_fast: Optional[pulumi.Input[bool]] = None,
                 enabled: Optional[pulumi.Input[bool]] = None,
                 preserve_data: Optional[pulumi.Input[bool]] = None):
        """
        :param pulumi.Input[bool] deprovision_fast: Whether the OS disk should be filled with `00h` bytes before reinstall. Defaults to `false`.
        :param pulumi.Input[bool] enabled: Whether the provider should favour reinstall over destroy and create. Defaults to `false`.
        :param pulumi.Input[bool] preserve_data: Whether the non-OS disks should be kept or wiped during reinstall. Defaults to `false`.
        """
        DeviceReinstallArgs._configure(
            lambda key, value: pulumi.set(__self__, key, value),
            deprovision_fast=deprovision_fast,
            enabled=enabled,
            preserve_data=preserve_data,
        )
    @staticmethod
    def _configure(
             _setter: Callable[[Any, Any], None],
             deprovision_fast: Optional[pulumi.Input[bool]] = None,
             enabled: Optional[pulumi.Input[bool]] = None,
             preserve_data: Optional[pulumi.Input[bool]] = None,
             opts: Optional[pulumi.ResourceOptions]=None):
        if deprovision_fast is not None:
            _setter("deprovision_fast", deprovision_fast)
        if enabled is not None:
            _setter("enabled", enabled)
        if preserve_data is not None:
            _setter("preserve_data", preserve_data)

    @property
    @pulumi.getter(name="deprovisionFast")
    def deprovision_fast(self) -> Optional[pulumi.Input[bool]]:
        """
        Whether the OS disk should be filled with `00h` bytes before reinstall. Defaults to `false`.
        """
        return pulumi.get(self, "deprovision_fast")

    @deprovision_fast.setter
    def deprovision_fast(self, value: Optional[pulumi.Input[bool]]):
        pulumi.set(self, "deprovision_fast", value)

    @property
    @pulumi.getter
    def enabled(self) -> Optional[pulumi.Input[bool]]:
        """
        Whether the provider should favour reinstall over destroy and create. Defaults to `false`.
        """
        return pulumi.get(self, "enabled")

    @enabled.setter
    def enabled(self, value: Optional[pulumi.Input[bool]]):
        pulumi.set(self, "enabled", value)

    @property
    @pulumi.getter(name="preserveData")
    def preserve_data(self) -> Optional[pulumi.Input[bool]]:
        """
        Whether the non-OS disks should be kept or wiped during reinstall. Defaults to `false`.
        """
        return pulumi.get(self, "preserve_data")

    @preserve_data.setter
    def preserve_data(self, value: Optional[pulumi.Input[bool]]):
        pulumi.set(self, "preserve_data", value)


@pulumi.input_type
class ProjectBgpConfigArgs:
    def __init__(__self__, *,
                 asn: pulumi.Input[int],
                 deployment_type: pulumi.Input[str],
                 max_prefix: Optional[pulumi.Input[int]] = None,
                 md5: Optional[pulumi.Input[str]] = None,
                 status: Optional[pulumi.Input[str]] = None):
        """
        :param pulumi.Input[int] asn: Autonomous System Number for local BGP deployment
        :param pulumi.Input[str] deployment_type: `private` or `public`, the `private` is likely to be usable immediately, the `public` will need to be review by Equinix Metal engineers
        :param pulumi.Input[int] max_prefix: The maximum number of route filters allowed per server
        :param pulumi.Input[str] md5: Password for BGP session in plaintext (not a checksum)
        :param pulumi.Input[str] status: status of BGP configuration in the project
        """
        ProjectBgpConfigArgs._configure(
            lambda key, value: pulumi.set(__self__, key, value),
            asn=asn,
            deployment_type=deployment_type,
            max_prefix=max_prefix,
            md5=md5,
            status=status,
        )
    @staticmethod
    def _configure(
             _setter: Callable[[Any, Any], None],
             asn: pulumi.Input[int],
             deployment_type: pulumi.Input[str],
             max_prefix: Optional[pulumi.Input[int]] = None,
             md5: Optional[pulumi.Input[str]] = None,
             status: Optional[pulumi.Input[str]] = None,
             opts: Optional[pulumi.ResourceOptions]=None):
        _setter("asn", asn)
        _setter("deployment_type", deployment_type)
        if max_prefix is not None:
            _setter("max_prefix", max_prefix)
        if md5 is not None:
            _setter("md5", md5)
        if status is not None:
            _setter("status", status)

    @property
    @pulumi.getter
    def asn(self) -> pulumi.Input[int]:
        """
        Autonomous System Number for local BGP deployment
        """
        return pulumi.get(self, "asn")

    @asn.setter
    def asn(self, value: pulumi.Input[int]):
        pulumi.set(self, "asn", value)

    @property
    @pulumi.getter(name="deploymentType")
    def deployment_type(self) -> pulumi.Input[str]:
        """
        `private` or `public`, the `private` is likely to be usable immediately, the `public` will need to be review by Equinix Metal engineers
        """
        return pulumi.get(self, "deployment_type")

    @deployment_type.setter
    def deployment_type(self, value: pulumi.Input[str]):
        pulumi.set(self, "deployment_type", value)

    @property
    @pulumi.getter(name="maxPrefix")
    def max_prefix(self) -> Optional[pulumi.Input[int]]:
        """
        The maximum number of route filters allowed per server
        """
        return pulumi.get(self, "max_prefix")

    @max_prefix.setter
    def max_prefix(self, value: Optional[pulumi.Input[int]]):
        pulumi.set(self, "max_prefix", value)

    @property
    @pulumi.getter
    def md5(self) -> Optional[pulumi.Input[str]]:
        """
        Password for BGP session in plaintext (not a checksum)
        """
        return pulumi.get(self, "md5")

    @md5.setter
    def md5(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "md5", value)

    @property
    @pulumi.getter
    def status(self) -> Optional[pulumi.Input[str]]:
        """
        status of BGP configuration in the project
        """
        return pulumi.get(self, "status")

    @status.setter
    def status(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "status", value)


@pulumi.input_type
class SpotMarketRequestInstanceParametersArgs:
    def __init__(__self__, *,
                 billing_cycle: pulumi.Input[str],
                 hostname: pulumi.Input[str],
                 operating_system: pulumi.Input[str],
                 plan: pulumi.Input[str],
                 always_pxe: Optional[pulumi.Input[bool]] = None,
                 customdata: Optional[pulumi.Input[str]] = None,
                 description: Optional[pulumi.Input[str]] = None,
                 features: Optional[pulumi.Input[Sequence[pulumi.Input[str]]]] = None,
                 ipxe_script_url: Optional[pulumi.Input[str]] = None,
                 locked: Optional[pulumi.Input[bool]] = None,
                 project_ssh_keys: Optional[pulumi.Input[Sequence[pulumi.Input[str]]]] = None,
                 tags: Optional[pulumi.Input[Sequence[pulumi.Input[str]]]] = None,
                 termintation_time: Optional[pulumi.Input[str]] = None,
                 user_ssh_keys: Optional[pulumi.Input[Sequence[pulumi.Input[str]]]] = None,
                 userdata: Optional[pulumi.Input[str]] = None):
        SpotMarketRequestInstanceParametersArgs._configure(
            lambda key, value: pulumi.set(__self__, key, value),
            billing_cycle=billing_cycle,
            hostname=hostname,
            operating_system=operating_system,
            plan=plan,
            always_pxe=always_pxe,
            customdata=customdata,
            description=description,
            features=features,
            ipxe_script_url=ipxe_script_url,
            locked=locked,
            project_ssh_keys=project_ssh_keys,
            tags=tags,
            termintation_time=termintation_time,
            user_ssh_keys=user_ssh_keys,
            userdata=userdata,
        )
    @staticmethod
    def _configure(
             _setter: Callable[[Any, Any], None],
             billing_cycle: pulumi.Input[str],
             hostname: pulumi.Input[str],
             operating_system: pulumi.Input[str],
             plan: pulumi.Input[str],
             always_pxe: Optional[pulumi.Input[bool]] = None,
             customdata: Optional[pulumi.Input[str]] = None,
             description: Optional[pulumi.Input[str]] = None,
             features: Optional[pulumi.Input[Sequence[pulumi.Input[str]]]] = None,
             ipxe_script_url: Optional[pulumi.Input[str]] = None,
             locked: Optional[pulumi.Input[bool]] = None,
             project_ssh_keys: Optional[pulumi.Input[Sequence[pulumi.Input[str]]]] = None,
             tags: Optional[pulumi.Input[Sequence[pulumi.Input[str]]]] = None,
             termintation_time: Optional[pulumi.Input[str]] = None,
             user_ssh_keys: Optional[pulumi.Input[Sequence[pulumi.Input[str]]]] = None,
             userdata: Optional[pulumi.Input[str]] = None,
             opts: Optional[pulumi.ResourceOptions]=None):
        _setter("billing_cycle", billing_cycle)
        _setter("hostname", hostname)
        _setter("operating_system", operating_system)
        _setter("plan", plan)
        if always_pxe is not None:
            _setter("always_pxe", always_pxe)
        if customdata is not None:
            _setter("customdata", customdata)
        if description is not None:
            _setter("description", description)
        if features is not None:
            _setter("features", features)
        if ipxe_script_url is not None:
            _setter("ipxe_script_url", ipxe_script_url)
        if locked is not None:
            _setter("locked", locked)
        if project_ssh_keys is not None:
            _setter("project_ssh_keys", project_ssh_keys)
        if tags is not None:
            _setter("tags", tags)
        if termintation_time is not None:
            _setter("termintation_time", termintation_time)
        if user_ssh_keys is not None:
            _setter("user_ssh_keys", user_ssh_keys)
        if userdata is not None:
            _setter("userdata", userdata)

    @property
    @pulumi.getter(name="billingCycle")
    def billing_cycle(self) -> pulumi.Input[str]:
        return pulumi.get(self, "billing_cycle")

    @billing_cycle.setter
    def billing_cycle(self, value: pulumi.Input[str]):
        pulumi.set(self, "billing_cycle", value)

    @property
    @pulumi.getter
    def hostname(self) -> pulumi.Input[str]:
        return pulumi.get(self, "hostname")

    @hostname.setter
    def hostname(self, value: pulumi.Input[str]):
        pulumi.set(self, "hostname", value)

    @property
    @pulumi.getter(name="operatingSystem")
    def operating_system(self) -> pulumi.Input[str]:
        return pulumi.get(self, "operating_system")

    @operating_system.setter
    def operating_system(self, value: pulumi.Input[str]):
        pulumi.set(self, "operating_system", value)

    @property
    @pulumi.getter
    def plan(self) -> pulumi.Input[str]:
        return pulumi.get(self, "plan")

    @plan.setter
    def plan(self, value: pulumi.Input[str]):
        pulumi.set(self, "plan", value)

    @property
    @pulumi.getter(name="alwaysPxe")
    def always_pxe(self) -> Optional[pulumi.Input[bool]]:
        return pulumi.get(self, "always_pxe")

    @always_pxe.setter
    def always_pxe(self, value: Optional[pulumi.Input[bool]]):
        pulumi.set(self, "always_pxe", value)

    @property
    @pulumi.getter
    def customdata(self) -> Optional[pulumi.Input[str]]:
        return pulumi.get(self, "customdata")

    @customdata.setter
    def customdata(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "customdata", value)

    @property
    @pulumi.getter
    def description(self) -> Optional[pulumi.Input[str]]:
        return pulumi.get(self, "description")

    @description.setter
    def description(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "description", value)

    @property
    @pulumi.getter
    def features(self) -> Optional[pulumi.Input[Sequence[pulumi.Input[str]]]]:
        return pulumi.get(self, "features")

    @features.setter
    def features(self, value: Optional[pulumi.Input[Sequence[pulumi.Input[str]]]]):
        pulumi.set(self, "features", value)

    @property
    @pulumi.getter(name="ipxeScriptUrl")
    def ipxe_script_url(self) -> Optional[pulumi.Input[str]]:
        return pulumi.get(self, "ipxe_script_url")

    @ipxe_script_url.setter
    def ipxe_script_url(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "ipxe_script_url", value)

    @property
    @pulumi.getter
    def locked(self) -> Optional[pulumi.Input[bool]]:
        return pulumi.get(self, "locked")

    @locked.setter
    def locked(self, value: Optional[pulumi.Input[bool]]):
        pulumi.set(self, "locked", value)

    @property
    @pulumi.getter(name="projectSshKeys")
    def project_ssh_keys(self) -> Optional[pulumi.Input[Sequence[pulumi.Input[str]]]]:
        return pulumi.get(self, "project_ssh_keys")

    @project_ssh_keys.setter
    def project_ssh_keys(self, value: Optional[pulumi.Input[Sequence[pulumi.Input[str]]]]):
        pulumi.set(self, "project_ssh_keys", value)

    @property
    @pulumi.getter
    def tags(self) -> Optional[pulumi.Input[Sequence[pulumi.Input[str]]]]:
        return pulumi.get(self, "tags")

    @tags.setter
    def tags(self, value: Optional[pulumi.Input[Sequence[pulumi.Input[str]]]]):
        pulumi.set(self, "tags", value)

    @property
    @pulumi.getter(name="termintationTime")
    def termintation_time(self) -> Optional[pulumi.Input[str]]:
        return pulumi.get(self, "termintation_time")

    @termintation_time.setter
    def termintation_time(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "termintation_time", value)

    @property
    @pulumi.getter(name="userSshKeys")
    def user_ssh_keys(self) -> Optional[pulumi.Input[Sequence[pulumi.Input[str]]]]:
        return pulumi.get(self, "user_ssh_keys")

    @user_ssh_keys.setter
    def user_ssh_keys(self, value: Optional[pulumi.Input[Sequence[pulumi.Input[str]]]]):
        pulumi.set(self, "user_ssh_keys", value)

    @property
    @pulumi.getter
    def userdata(self) -> Optional[pulumi.Input[str]]:
        return pulumi.get(self, "userdata")

    @userdata.setter
    def userdata(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "userdata", value)


@pulumi.input_type
class VolumeAttachmentArgs:
    def __init__(__self__, *,
                 href: Optional[pulumi.Input[str]] = None):
        VolumeAttachmentArgs._configure(
            lambda key, value: pulumi.set(__self__, key, value),
            href=href,
        )
    @staticmethod
    def _configure(
             _setter: Callable[[Any, Any], None],
             href: Optional[pulumi.Input[str]] = None,
             opts: Optional[pulumi.ResourceOptions]=None):
        if href is not None:
            _setter("href", href)

    @property
    @pulumi.getter
    def href(self) -> Optional[pulumi.Input[str]]:
        return pulumi.get(self, "href")

    @href.setter
    def href(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "href", value)


@pulumi.input_type
class VolumeSnapshotPolicyArgs:
    def __init__(__self__, *,
                 snapshot_count: pulumi.Input[int],
                 snapshot_frequency: pulumi.Input[str]):
        VolumeSnapshotPolicyArgs._configure(
            lambda key, value: pulumi.set(__self__, key, value),
            snapshot_count=snapshot_count,
            snapshot_frequency=snapshot_frequency,
        )
    @staticmethod
    def _configure(
             _setter: Callable[[Any, Any], None],
             snapshot_count: pulumi.Input[int],
             snapshot_frequency: pulumi.Input[str],
             opts: Optional[pulumi.ResourceOptions]=None):
        _setter("snapshot_count", snapshot_count)
        _setter("snapshot_frequency", snapshot_frequency)

    @property
    @pulumi.getter(name="snapshotCount")
    def snapshot_count(self) -> pulumi.Input[int]:
        return pulumi.get(self, "snapshot_count")

    @snapshot_count.setter
    def snapshot_count(self, value: pulumi.Input[int]):
        pulumi.set(self, "snapshot_count", value)

    @property
    @pulumi.getter(name="snapshotFrequency")
    def snapshot_frequency(self) -> pulumi.Input[str]:
        return pulumi.get(self, "snapshot_frequency")

    @snapshot_frequency.setter
    def snapshot_frequency(self, value: pulumi.Input[str]):
        pulumi.set(self, "snapshot_frequency", value)


@pulumi.input_type
class GetFacilityCapacityArgs:
    def __init__(__self__, *,
                 plan: str,
                 quantity: Optional[int] = None):
        """
        :param str plan: device plan to check
        :param int quantity: number of device to check
        """
        GetFacilityCapacityArgs._configure(
            lambda key, value: pulumi.set(__self__, key, value),
            plan=plan,
            quantity=quantity,
        )
    @staticmethod
    def _configure(
             _setter: Callable[[Any, Any], None],
             plan: str,
             quantity: Optional[int] = None,
             opts: Optional[pulumi.ResourceOptions]=None):
        _setter("plan", plan)
        if quantity is not None:
            _setter("quantity", quantity)

    @property
    @pulumi.getter
    def plan(self) -> str:
        """
        device plan to check
        """
        return pulumi.get(self, "plan")

    @plan.setter
    def plan(self, value: str):
        pulumi.set(self, "plan", value)

    @property
    @pulumi.getter
    def quantity(self) -> Optional[int]:
        """
        number of device to check
        """
        return pulumi.get(self, "quantity")

    @quantity.setter
    def quantity(self, value: Optional[int]):
        pulumi.set(self, "quantity", value)


@pulumi.input_type
class GetMetroCapacityArgs:
    def __init__(__self__, *,
                 plan: str,
                 quantity: Optional[int] = None):
        """
        :param str plan: device plan to check
        :param int quantity: number of device to check
        """
        GetMetroCapacityArgs._configure(
            lambda key, value: pulumi.set(__self__, key, value),
            plan=plan,
            quantity=quantity,
        )
    @staticmethod
    def _configure(
             _setter: Callable[[Any, Any], None],
             plan: str,
             quantity: Optional[int] = None,
             opts: Optional[pulumi.ResourceOptions]=None):
        _setter("plan", plan)
        if quantity is not None:
            _setter("quantity", quantity)

    @property
    @pulumi.getter
    def plan(self) -> str:
        """
        device plan to check
        """
        return pulumi.get(self, "plan")

    @plan.setter
    def plan(self, value: str):
        pulumi.set(self, "plan", value)

    @property
    @pulumi.getter
    def quantity(self) -> Optional[int]:
        """
        number of device to check
        """
        return pulumi.get(self, "quantity")

    @quantity.setter
    def quantity(self, value: Optional[int]):
        pulumi.set(self, "quantity", value)


